#property copyright "Copyright  2007, "
#property link      ""
 
#define STUPID 0x60BE57
 
extern string     Lots_Desc         =  " 0   ";
extern double     Lots              =  1;
 
extern string     RiskPercentage_Desc =  "    -- % .  0     ,  Lots > 0   ";
extern int        RiskPercentage    =  0;
 
extern int        Slippage          =  25;
 
extern string     Target_Desc       =  " ,  0    90-200";
extern int        Target            =  0 ;
 
extern string     Loss_Desc         =  " ,  0    30-80";
extern int        Loss              =  0;
 

extern string     _  =  " ( -1 .. ma shift 1)";
extern int        =24;
extern int        =0;
extern int        _=0;

 
extern string     MaxOrders_Desc    =  " 0       1-3";
extern int        MaxOrders         =  1;
 
double LotsToBid;
string symbol;
bool _?;
bool _?;
datetime sendorder=0; 
 //---------------------------

//-------  -------
extern string =" -----------------------------------------------";
extern int        MA_period        = 144;
extern int     _ =4;
extern int     _  =0;
extern int     profit        = 50;


  
 //--------------------------------------------------------------
//  
void CloseBuys(int MagicNumber, int Slippage)
{
   for(int i = 0; i < OrdersTotal(); i++)
   {
      // already closed
      if(OrderSelect(i, SELECT_BY_POS) == false) continue;
      // not current symbol
      if(OrderSymbol() != Symbol()) continue;
      // order was opened in another way
      if(OrderMagicNumber() != MagicNumber) continue;
      
      if(OrderType() == OP_BUY)
      {
         if(OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid,Digits), Slippage, Blue))
         {
            i--;
         }
         RefreshRates();
      }
   }
}
 //-----------------------------------------------------
 
//  
void CloseSells(int MagicNumber, int Slippage)
{
   for(int i = 0; i < OrdersTotal(); i++)
   {
      // already closed
      if(OrderSelect(i, SELECT_BY_POS) == false) continue;
      // not current symbol
      if(OrderSymbol() != Symbol()) continue;
      // order was opened in another way
      if(OrderMagicNumber() != MagicNumber) continue;
      
      if(OrderType() == OP_SELL)
      {
         if (OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask,Digits), Slippage, Red))
         {
            i--;
         }
         RefreshRates();
      }
   }
}
 //----------------------------------------------------
 
//  -  
int GetOrdersCount(int MagicNumber, int Type)
{
   int count = 0;
   
   for(int i = 0; i < OrdersTotal(); i++)
   {
      // already closed
      if(OrderSelect(i, SELECT_BY_POS) == false) continue;
      // not current symbol
      if(OrderSymbol() != Symbol()) continue;
      // order was opened in another way
      if(OrderMagicNumber() != MagicNumber) continue;
      
      if(OrderType() == Type)
      {
         count++;
      }
   }
   
   return (count);
}
 //-------------------------------------------------------
 
//   
double GetLotsToBid(int RiskPercentage)
{
   double margin = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   double minLot = MarketInfo(Symbol(), MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   double step = MarketInfo(Symbol(), MODE_LOTSTEP);
   double account = AccountFreeMargin();
   
   double percentage = account*RiskPercentage/100;
   
   double lots = MathRound(percentage/margin/step)*step;
   
   if(lots < minLot)
   {
      lots = minLot;
   }
   
   if(lots > maxLot)
   {
      lots = maxLot;
   }
 
   return (lots);
}
 //----------------------------------------------------
 
// 
void OpenBuy()
{

   double TP = 0;
   if (Target > 0)
   {
      TP = NormalizeDouble(Ask,Digits) + Target*Point;
   }

   double SL = 0;
   if (Loss > 0)
   {
      SL = NormalizeDouble(Ask,Digits) - Loss*Point;
   }
   
   if (Lots == 0) LotsToBid = GetLotsToBid(RiskPercentage);
    
   
   OrderSend(Symbol(), OP_BUY, LotsToBid,  NormalizeDouble(Ask,Digits), Slippage, SL, TP, NULL, STUPID, 0, Blue);
sendorder=iTime(Symbol(), PERIOD_D1,    //    
                                  iBarShift(Symbol(), PERIOD_D1, Time[1]));
}
 //----------------------------------------------------
 
// 
void OpenSell()
{

   double TP = 0;
   if (Target > 0)
   {
      TP = NormalizeDouble(Bid,Digits) - Target*Point;
   }

   double SL = 0;
   if (Loss > 0)
   {
      SL = NormalizeDouble(Bid,Digits) + Loss*Point;
   }
   
   if (Lots == 0) LotsToBid = GetLotsToBid(RiskPercentage);
   
   
   OrderSend(Symbol(), OP_SELL, LotsToBid,  NormalizeDouble(Bid,Digits), Slippage,  SL, TP, NULL, STUPID, 0, Red);
sendorder=iTime(Symbol(), PERIOD_D1,    //    
                                  iBarShift(Symbol(), PERIOD_D1, Time[1]));
}
 //------------------------------------------------------
 //      
void Check()
{
//
    
              if(mMA(MA_period,_,_,2)>Close[2]&&
                 mMA(MA_period,_,_,1)<Close[1]
              ){CheckBuy() ;}           //    buy

              if(mMA(MA_period,_,_,2)<Close[2]&&
                 mMA(MA_period,_,_,1)>Close[1]
              ){CheckSell(); }           //    sell
                                           
                                        
                                        
//
 
}

double mMA(int P,int method,int price,int shift)
{return(iMA(symbol, 0, P*1, 0, method, price,  shift));} 
 
  
 //--------------------------------------------------------------
 //--------------------------------------------------------------
   
void CheckBuy()
{
      if (GetOrdersCount(STUPID, OP_SELL) > 0)
      {
         CloseSells(STUPID, Slippage);
        
      }
      if (GetOrdersCount(STUPID, OP_BUY) < MaxOrders || MaxOrders == 0) 
      {
         OpenBuy();
_?=2;
_?=0;
      }}
void CheckSell()
{
      if (GetOrdersCount(STUPID, OP_BUY) > 0)
      {
         CloseBuys(STUPID, Slippage);
      }
      if (GetOrdersCount(STUPID, OP_SELL) < MaxOrders || MaxOrders == 0) 
      {
         OpenSell();
_?=2;
_?=0; 
      }}
 //--------------------------------------------------------------
 //--------------------------------------------------------------
int init()
{

   LotsToBid = Lots;
   symbol = Symbol();
}
 //--------------------------------------------------------------
int start()
{
   // Check for open new orders and close current ones
   Check();

   return(0);
}